// knfo̓vOTv
//
#include "stdafx.h"
#include "LogManager.h"
#include <windows.h>
#include <conio.h>

#define NUM_THREAD	10
#define NUM_COUNT	100
//#define SYNC_MUTEX	// ~[ebNXœƂăJEgAbv

HANDLE ahThread[NUM_THREAD];
int nThread = 0;
int count = 0;
HANDLE mutex;

void subThread(int nh)
{
	LOGF_DEBUG(_T("subThread %d Jn"), nh);
	for (int n = 0; n < NUM_COUNT; ++n)
	{
#ifdef SYNC_MUTEX
		WaitForSingleObject(mutex, INFINITE);
#endif
		++count;
		LOGF_DEBUG(_T("subThread %d count=%d"), nh, count);
#ifdef SYNC_MUTEX
		ReleaseMutex(mutex);
#endif
		Sleep(10);
	}
	LOGF_DEBUG(_T("subThread %d I"), nh);
}

int _tmain()
{
	LOG_DEBUG(_T("main Jn"));
	int ret = 0;

	mutex = CreateMutex(NULL, FALSE, NULL);
	for (nThread = 0; nThread < NUM_THREAD; ++nThread)
	{
		DWORD dwID;
		ahThread[nThread] = CreateThread(0, 0, (LPTHREAD_START_ROUTINE)subThread, (void*)nThread, 0, &dwID);
		if (ahThread[nThread] == NULL)
		{
			LOGF_ERROR(_T("CreateThread %d error (%d)"), nThread, GetLastError());
			ret = -1;
		}
	}
	for (int n = 0; n < nThread; ++n)
	{
		DWORD dwRes = WaitForSingleObject(ahThread[n], 10000);
		if (dwRes != WAIT_OBJECT_0)
		{
			LOGF_ERROR(_T("WaitForSingleObject %d error (%d)"), dwRes);
			ret = -1;
		}
	}
	LOGF_DEBUG(_T("count=%d"), count);
	if (count != NUM_COUNT * NUM_THREAD)
	{
		LOGF_ERROR(_T("count error (%d)"), count);
		ret = -2;
	}
	ReleaseMutex(mutex);

	LOGF_DEBUG(_T("main I (%d)"), ret);
	return ret;
}
